unit npi;

interface

uses Windows;

type
  PImageInfo = ^TImageInfo;
  TImageInfo = packed record
    Width: Longint;                       // signed 32bit
    Height: Longint;                      // signed 32bit
    BitPerPixel: Longint;                 // signed 32bit, 1 or 4 or 8 or 24 or 32
    //Palette: array[0..255, 0..3] of Byte; // unsigned 8bit, order: B, G, R, Reserved (same RGBQUAD)
  end;

  PImageMetaInfo = ^TImageMetaInfo;
  TImageMetaInfo = packed record
    SrcBitPerPixel: Longint;              // signed 32bit, Original BPP
    FormatName: array[0..255] of Char;
    Comment: PChar;
  end;

  TImageFilter = class(TObject)
  protected
    function GetName: string; virtual; abstract;
  public
    function Test(InBuf: PChar; InBufSize: Longint): Boolean; virtual; abstract;
    function GetInfo(InBuf: PChar; InBufSize: Longint; var ImageInfo: TImageInfo;
      ImageMetaInfo: PImageMetaInfo): Integer; virtual; abstract;
    function Decode(InBuf: PChar; InBufSize: Longint; OutBuf: PChar;
      OutBufSize: Longint): Integer; virtual; abstract;
    procedure FreeImageMetaInfo(var ImageMetaInfo: TImageMetaInfo); virtual; abstract;
    property Name: string read GetName;
  end;

  PFileInfo = ^TFileInfo;
  TFileInfo = packed record
    Name: array[0..1023] of Char;
    MTime: Longint;
    FileType: Longint;
    Offset: Integer;
    FileSize: Integer;
    CompSize: Integer;
  end;
{
  TArchiver = class(TObject)
  public
    function GetFileList(const ArcFileName: string): PFileInfo; override;
    function  ExtractFile(const FileInfo: TFileInfo; OutBuf: PChar;
      OutBufSize: Longint): Integer; virtual; abstract;
    property ArcFileName: string read FArcFileName;
  end;
}
const
  { for TFileInfo }
  FTYPE_FILE = 0;
  FTYPE_DIR = 1;

  // Ƃ肠SPIɂ킹Ă
  NPI_NOSUPPORT = 2;
  NPI_MEMNEEDMORE = 5;

implementation

end.
